/*  @(#)34  1.2 src/provisioning/scenario/src/com/tivoli/am/fim/provisioning/scenario/TAMUserType.java, amws.provisioning, fim611, 060808b 2/24/05 19:05:12  */

/*
 *
 * File Name: TAMUserType.java
 *
 * IBM Confidential
 * Object Code Only Source Materials
 * 5747-SM3
 * (c) Copyright International Business Machines Corp. 2004
 * The source code for this program is not published or otherwise divested
 * of its trade secrets, irrespective of what has been deposited with the
 * U.S. Copyright Office.
 */

package com.tivoli.am.fim.provisioning.scenario;

/**
 * A class for an example WS-Provisioning provision parameter. 
 * It encapsulates a TAMUser with the following members:
 * - ip_identifier
 * - username
 * - password
 * - email
 *
 * This is only an EXAMPLE implementation of what a customer will need to have for their own specific data.
 */
public class TAMUserType  implements java.io.Serializable 
{
    public static final String TAMUserType_java_sourceCodeID = "$Id: @(#)34    1.2  src/provisioning/scenario/src/com/tivoli/am/fim/provisioning/scenario/TAMUserType.java, amws.provisioning, fim611, 060808b  2/24/05  19:05:12 $";

    public static final String TAMUserType_java_copyright = com.tivoli.am.fim.constants.FIMCopyrightConstants.FULL_COPYRIGHT;

    private java.lang.String ip_identifier;
    private java.lang.String username;
    private java.lang.String password;
    private java.lang.String email;

    public TAMUserType() {
    }

    public java.lang.String getIp_identifier() {
        return ip_identifier;
    }

    public void setIp_identifier(java.lang.String ip_identifier) {
        this.ip_identifier = ip_identifier;
    }

    public java.lang.String getUsername() {
        return username;
    }

    public void setUsername(java.lang.String username) {
        this.username = username;
    }

    public java.lang.String getPassword() {
        return password;
    }

    public void setPassword(java.lang.String password) {
        this.password = password;
    }

    public java.lang.String getEmail() {
        return email;
    }

    public void setEmail(java.lang.String email) {
        this.email = email;
    }

	/**
	 * Public method that converts this object into a org.apache.axis.message.MessageElement[]
	 * This saves the ITDI Script component from having to do it.
	 *
	 * @return MessageElement[] The new Array
	 * @throws SOAPException If an error occurs during MessageElement creation
	 */
	public org.apache.axis.message.MessageElement[] toMessageElementArray() throws javax.xml.soap.SOAPException
	{
		javax.xml.namespace.QName qname = new javax.xml.namespace.QName("http://www.ibm.com/TAMUser", "TAMUser");
		org.apache.axis.message.MessageElement any = new org.apache.axis.message.MessageElement();
		any.setQName(qname);
		any.setObjectValue(this);
		
		org.apache.axis.message.MessageElement[] anyArray = { any };

		return anyArray;
	}

    private java.lang.Object __equalsCalc = null;
    public synchronized boolean equals(java.lang.Object obj) {
        if (!(obj instanceof TAMUserType)) return false;
        TAMUserType other = (TAMUserType) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.ip_identifier==null && other.getIp_identifier()==null) || 
             (this.ip_identifier!=null &&
              this.ip_identifier.equals(other.getIp_identifier()))) &&
            ((this.username==null && other.getUsername()==null) || 
             (this.username!=null &&
              this.username.equals(other.getUsername()))) &&
            ((this.password==null && other.getPassword()==null) || 
             (this.password!=null &&
              this.password.equals(other.getPassword()))) &&
            ((this.email==null && other.getEmail()==null) || 
             (this.email!=null &&
              this.email.equals(other.getEmail())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getIp_identifier() != null) {
            _hashCode += getIp_identifier().hashCode();
        }
        if (getUsername() != null) {
            _hashCode += getUsername().hashCode();
        }
        if (getPassword() != null) {
            _hashCode += getPassword().hashCode();
        }
        if (getEmail() != null) {
            _hashCode += getEmail().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(TAMUserType.class);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("http://www.ibm.com/TAMUser", "TAMUserType"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("ip_identifier");
        elemField.setXmlName(new javax.xml.namespace.QName("", "ip_identifier"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setMinOccurs(0);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("username");
        elemField.setXmlName(new javax.xml.namespace.QName("", "username"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setMinOccurs(0);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("password");
        elemField.setXmlName(new javax.xml.namespace.QName("", "password"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setMinOccurs(0);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("email");
        elemField.setXmlName(new javax.xml.namespace.QName("", "email"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setMinOccurs(0);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           java.lang.String mechType, 
           java.lang.Class _javaType,  
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           java.lang.String mechType, 
           java.lang.Class _javaType,  
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
